
/* Numerical Integration Example that uses MPI error checking functions */

#include <sys/types.h>



#include <unistd.h>
#include "mpi.h"
#include <stdio.h>
#include <signal.h>

int main(int argc, char *argv[])
{
  int provided;
  int pid = getpid();
  printf ("\n(client, pid %d): Staring client", pid);
  MPI_Init_thread(&argc,&argv, MPI_THREAD_MULTIPLE, &provided);
  MPI_Comm comm ;
  MPI_Errhandler_set(MPI_COMM_WORLD,MPI_ERRORS_RETURN);

  // Wait till the port file appears
  FILE* fp = NULL ;
  while (!(fp = fopen ("portfile", "r"))){
  }
  sleep (2);

  char port[20560];
  fscanf (fp, "%s\n", port);
  fclose(fp);
  printf ("\n(client, pid %d): Port : %s", pid, port);

  int errCode = MPI_Comm_connect(port, MPI_INFO_NULL, 0, MPI_COMM_SELF, &comm);
  int errclass ;
  MPI_Error_class(errCode, &errclass);
  if (errclass == MPI_SUCCESS) {
    printf ("\n(client, pid %d): Successful connection", pid);
    MPI_Comm_disconnect (&comm);
  } else {
    printf ("\n(client, pid %d): *****Error: Connection attempt failed", pid);
  }

  printf ("\n(client, pid %d): Exit\n", pid);
  MPI_Finalize();                       
}
