
/* Numerical Integration Example that uses MPI error checking functions */

#include <sys/types.h>



#include <unistd.h>
#include "mpi.h"
#include <stdio.h>
#include <signal.h>

int main(int argc, char *argv[])
{
  int provided;
  MPI_Init_thread(&argc,&argv, MPI_THREAD_MULTIPLE, &provided);
  int pid = getpid ();
  printf ("\n(server, pid=%d): starting server", pid);
  char portname[MPI_MAX_PORT_NAME];
  MPI_Open_port(MPI_INFO_NULL, portname);
  FILE* fp = fopen ("portfile", "w");
  printf ("\n(server, pid=%d): port : %s", pid, portname);
  fprintf (fp, "%s\n", portname);
  fclose(fp);
  MPI_Comm comm;
  MPI_Comm_accept (portname, MPI_INFO_NULL, 0, MPI_COMM_SELF, &comm);
  printf ("\n(server, pid=%d): Accepted conenction", pid);
  MPI_Comm_disconnect (&comm);
  MPI_Close_port(portname);

  printf ("\n(Server, pid %d): Port closed. Shutdown\n", pid);
  MPI_Finalize();                       

}
